﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace csharp2vala
{
    class FileFunctions
    {

        public String get_homedir(){
            String home = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            return home;
        }

        public void save_rc(String appresource , String thevalue){

            //-- needs something like .theapp/setting1.rc --
            //log(get_homedir() + "/" + dirname(appresource));
            CreateDirectory(get_homedir() + "/" + dirname(appresource));
            WriteAllText(get_homedir() + "/" + appresource, thevalue);
        }

        public String load_rc(String appresource)
        {

            //-- needs something like .theapp/setting1.rc --
            //log(get_homedir() + "/" + dirname(appresource));
            CreateDirectory(get_homedir() + "/" + dirname(appresource));
            //WriteAllText(get_homedir() + "/" + appresource, thevalue);
            String myString = "";
            try{
                myString = File.ReadAllText(get_homedir() + "/" + appresource);
            }catch{
            }

            return myString;
        }

        public virtual bool RunCommand(string szCmd, string szArgs, int wait)
        {

            // shorter:
            // System.Diagnostics.Process proc = new System.Diagnostics.Process();
            // proc.StartInfo.FileName = "pbrush.exe";
            // proc.Start();
            // proc.WaitForExit();

            if (szCmd == null) return false;
            System.Diagnostics.Process myproc = new System.Diagnostics.Process();
            myproc.EnableRaisingEvents = false;
            myproc.StartInfo.FileName = szCmd;
            myproc.StartInfo.Arguments = szArgs;
            try{
            if (myproc.Start())
            {
                //Using WaitForExit( ) allows for the host program
                //to wait for the command its executing before it continues
                if (wait == 1) myproc.WaitForExit();
                else myproc.Close();
                return true;
            }
            else return false;
            }catch{
            }
            return false;
        }



        public bool startswith(String thestring , String theline){

            String trimmed = theline.Trim();
            if(trimmed.Length >= thestring.Length)
            {
                if(trimmed.Substring(0,thestring.Length).Equals(thestring))
                {
                    return true;
                }
            }
            return false;
        }

        public bool isWindows(){

            String tempDir = System.IO.Path.GetTempPath();
            //FF.log(tempDir);
            if( tempDir.Contains("/")){
                return false;
            }
            return true;
        }

        public String[] readFilenamesToStringArray(String strDir, String suffix)
        {

            String[] myListRet = new String[0];
 
            int c;

            String[] myDirList = Directory.GetFileSystemEntries(strDir);

            //-- find out number of matching files --
            c = 0;
            foreach (string str in myDirList)
            {
                if(0 == (File.GetAttributes(str) & FileAttributes.Directory)){
                    if(str.Substring(str.Length - suffix.Length).Equals(suffix)){
                        c++;
                    }
                }
            }

            //log("--------" + c);

            //-- add matching files to array --
            String[] myList = new String[c+1];
            c = 0;
            foreach (string str in myDirList)
            {
                if (0 == (File.GetAttributes(str) & FileAttributes.Directory))
                {
                    if(str.Substring(str.Length - suffix.Length).Equals(suffix)){
                        myList[c] = str;
                        //log("test --- " + str + "--<");
                        c++;
                    }
                }
            }


            return (myList);

        }

        public string GetFileName(string thefile)
        {

            return (Path.GetFileName(thefile));
        }

        public String dirname(String thepath){
            return (Path.GetDirectoryName(thepath).Replace("\\", "/"));
        }


        public void CreateDirectory(string thedir)
        {
            Directory.CreateDirectory(thedir);
        }

        public void WriteAllText(String strFile, String mystring)
        {
  
            File.WriteAllText(strFile, mystring);


        }


        public void WriteAllLines(String strFile, String[] myList)
        {
            //strFile = strFile.Trim();
            File.WriteAllLines(strFile , myList);

            /*
            for (int n = 0; n < myList.Length; n++)
            {

                log(myList[n]);
            }
            */

        }

        public String[] ReadAllLines(String strFile)
        {



            String[] myListRet = new String[0];


            if (!File.Exists(strFile))
            {
                log("File not found error!");
                return (myListRet);
            }

            String[] myList = File.ReadAllLines(strFile);
            return (myList);

            /*
                        String[] myList;
                        string lineInput;
                        StreamReader sr;

                        int lineCounter = 0; 
             
                        //-- check number of lines --

                        sr = File.OpenText(strFile);




                        lineInput = sr.ReadLine();
                        while (lineInput != null)
                        {
                            lineInput = sr.ReadLine();
                            lineCounter++;
                        }
                        sr.Close();

                        //-- read file to array --

                        myList = new String[lineCounter];
                        //myList[0] = "" + lineCounter;
                        lineCounter = 0;

                        sr = File.OpenText(strFile);
                        lineInput = sr.ReadLine();
                        while (lineInput != null)
                        {
                            lineInput = sr.ReadLine();
                            myList[lineCounter] = lineInput;
                            lineCounter++;
                        }
                        sr.Close();
               return (myList);
            */




        }


        //-- some helper methods for shorter code --

        public void log(String thetext)
        {
            Program.form1.textBox2.AppendText(thetext + "\r\n");
            cprint(thetext);
        }

        public void cprint(String thetext)
        {
            Console.WriteLine(thetext);
        }


    }
}
