﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Text.RegularExpressions;

namespace csharp2vala
{
    class Glade
    {

        private FileFunctions FF = new FileFunctions();
        public bool noexpandflag = false;


        ArrayList container_list = new ArrayList();

        public String Containertype = "";

        ArrayList new_elements_chains = new ArrayList();


        public void FormToGlade(String projectFolder, String outPath)
        {
            FF.log("Converting WinForm to project.glade...");

            
            //FF.log(projectFolder);

            String inFile = projectFolder + "/Form1.Designer.cs";
            String outFile = outPath + "/project.glade";
            

            String[] theForm = FF.ReadAllLines(inFile);

            if(theForm.Length == 0){
                return;
            }

            String thenamespaceorig = theForm[0];
            thenamespaceorig = thenamespaceorig.Replace("namespace ", "");

            String thenamespace = thenamespaceorig.Substring(0, 1).ToLower();
            String thesub = "";
            for(int n=1;n<thenamespaceorig.Length;n++){
                thesub = thenamespaceorig.Substring(n,1);
                if(! thesub.ToLower().Equals(thesub)){
                    thenamespace = String.Concat (thenamespace , "_");
                    thenamespace = String.Concat(thenamespace, thesub.ToLower());
                    //thesub.ToLower;
                }else{
                    thenamespace = String.Concat(thenamespace, thesub.ToLower());
                }

            }


            thenamespace = String.Concat(thenamespace, "_form1");


            container_list.Clear();

 

            String theline;
            int i1;
            int i2;
            String widgetname;

            String[] widgetinfo;
            String widgettype;

            


            for(int i=0; i<theForm.Length;i++){


                theline = theForm[i];
                //FF.log("-> " + theline);

                if(theline.Contains(" = new System.Windows.Forms.")){
                    i1 = theline.IndexOf("this.") + 5;
                    i2 = theline.IndexOf(" = ");
                    widgetname = theline.Substring(i1, i2-i1);
                    //FF.log("--> " + widgetname);

                    //-- we support only some widgets --
                    noexpandflag = false;
                    //Containertype = "";
                    widgetinfo  = is_valid_widget(theline , widgetname , theForm, thenamespace);
                    if(!widgetinfo[0].Equals("")){

                        ArrayList widget = new ArrayList();
                        widgettype = widgetinfo[0];
                        //FF.log("---> " + widgettype);


                        widget.Add("        <child>");
                        widget.Add(widgettype);

                        //-- property --

                        for (int n = 1; n < widgetinfo.Length;n++ )
                        {
                            if (!widgetinfo[n].Equals(""))
                            {
                                widget.Add(widgetinfo[n]);
                            }
                        }

                        if (!Containertype.Equals("groupbox"))
                        {


                            widget.Add("--MARKER--");
                            widget.Add("          </widget>");
                            if (noexpandflag)
                            {

                                widget.Add("          <packing>");
                                widget.Add("            <property name=\"expand\">False</property>");


                            }else{

							    widget.Add("          <packing>");
                                widget.Add("            <property name=\"expand\">true</property>");
							}

                            widget.Add("        <---->");
                        }
                        else
                        {
  
                            widget.Add("          <packing>");
						    widget.Add("        <---->");	
                        }


                        if (Containertype.Equals("notebook"))
                        {
                            FF.log("NOTEBOOK");
                            String notebookname = xml_id(widgettype);

                            String Tabtext = "";
                            for (int ni = 0; ni < theForm.Length; ni++)
                            {


                                if (theForm[ni].Contains("this." + notebookname + ".Controls.Add"))
                                {
                                    ArrayList wl = new ArrayList();

                                    int t1 = theForm[ ni].IndexOf("(this.");
                                    int t2 = theForm[ni].IndexOf(")");
                                    String tabname = theForm[ni].Substring(t1 + 6, t2 - t1 - 6);
                                    wl.Add("            <child>");
                                    wl.Add("              <widget class=\"GtkFixed\" id=\"" + tabname + "\">");
                                    wl.Add("                <property name=\"visible\">True</property>");
                                    wl.Add("--MARKER--");

                                    wl.Add("              </widget>");                                    
                                    wl.Add("            </child>");
                                    
                                    wl.Add ("            <child>");
                                    
                                    wl.Add ("              <widget class=\"GtkLabel\" id=\"" + tabname + "_label\">");
                                    
                                    wl.Add ("                <property name=\"visible\">True</property>");
                                    
                                    //must get text!
                                    Tabtext = tabname;

                                    for (int n = 0; n < theForm.Length; n++)
                                    {
                                        if (theForm[n].Contains("this." + tabname + ".Text = "))
                                        {
                                            i1 = theForm[n].IndexOf("= \"") + 3;
                                            Tabtext = theForm[n].Substring(i1, theForm[n].Length - i1 - 2);
                                            //break;
                                        }
                                    }

                                    wl.Add ("                <property name=\"label\" translatable=\"yes\">" + Tabtext + "</property>");
                                    
                                    wl.Add ("              </widget>");
                                    
                                    wl.Add ("              <packing>");
                                    
                                    wl.Add ("                <property name=\"type\">tab</property>");
                                    
                                    wl.Add ("                <property name=\"tab_fill\">False</property>");
                                    
                                    //wl.Add ("              </packing>");
                                    
                                    wl.Add ("            </child>");

                                    container_list.Add(wl);

                                    //new_elements_chains.Add("-- (new) --> " + notebookname + " --> " + tabname + " (0, 0) [" + (container_list.Count - 1) + "]");

                                    
                                }

                            }
                        }

                        if (Containertype.Equals("splitcontainer"))
                        {

                            FF.log("SPLIT");
                            String splitname = xml_id(widgettype);

                            ArrayList widgetpanel1 = new ArrayList();
                            widgetpanel1.Add("<child>");
                            widgetpanel1.Add(" <widget class=\"GtkFixed\" id=\"" + splitname + ".Panel1\">");
                            widgetpanel1.Add("  <property name=\"visible\">True</property>");
                            widgetpanel1.Add("--MARKER--");

                            widgetpanel1.Add(" </widget>");

                            //widgetpanel1.Add("</child>");
                            widgetpanel1.Add(" <packing>");

                            widgetpanel1.Add(" <---->");
                            container_list.Add(widgetpanel1);

                            ArrayList widgetpanel2 = new ArrayList();
                            widgetpanel2.Add("<child>");
                            widgetpanel2.Add(" <widget class=\"GtkFixed\" id=\"" + splitname + ".Panel2\">");
                            widgetpanel2.Add("  <property name=\"visible\">True</property>");

                            widgetpanel2.Add("--MARKER--");
                            widgetpanel2.Add(" </widget>");
             
                            //widgetpanel2.Add("</child>");
                            widgetpanel2.Add(" <packing>");

                            widgetpanel2.Add(" <---->");
                            container_list.Add(widgetpanel2);

                            new_elements_chains.Add("-- (new) --> " + splitname + " --> " + splitname + ".Panel1 (0, 0) [" + (container_list.Count - 2) + "]");
                            new_elements_chains.Add("-- (new) --> " + splitname + " --> " + splitname + ".Panel2 (0, 0) [" + (container_list.Count - 1) + "]");

                        }



                        //FF.log(Containertype);

                        container_list.Add(widget);

                    }
                }

            }




            //String[] outList = (string[])o.ToArray(typeof(string));
            //FF.WriteAllLines(outFile + "2", outList);

            layout(theForm , thenamespace , outPath);

        }


        public void layout(String[] theform , string thenamespace , string outPath)
        {

            //-- look for children  --


            ArrayList container_children = new ArrayList();
            for (int n = 0; n < container_list.Count; n++)
            {
                //-- w is an arraylist containing the XML code of a container --
                ArrayList w = (ArrayList)container_list[n];

                String id = xml_id(w[1].ToString());
                //FF.log("---> " + id);

                //-- elements of created containers like flowlayouts --

                ArrayList li = find_nocontainer_children(id, theform);
                container_children.AddRange(li);

            }
            //-- elements of the root window --

            ArrayList root_children = find_root_children(theform);

            ArrayList final_list = new ArrayList();


            FF.log("------------------------------------");
            //return;
            for (int n = 0; n < root_children.Count; n++)
            {

                string[] root_elements = Regex.Split(root_children[n].ToString(), " --> ");
                int i1 = root_elements[2].IndexOf(" (");
                String third = root_elements[2].Substring(0, i1);
                //FF.log(third);
                for (int i = 0; i < container_children.Count; i++)
                {

                    string[] child_elements = Regex.Split(container_children[i].ToString(), " --> ");
                    //FF.log("    " + child_elements[1]);
                    if (third.Equals(child_elements[1]))
                    {
                        //final_list.Add();
                        FF.log(root_children[n] + " ------> " + child_elements[2]);
                    }
                }
            }

            /*
            for (int n = 0; n < container_notebook_list.Count; n++)
            {
                ArrayList w = (ArrayList)container_notebook_list[n];
                for (int z = 0; z < w.Count; z++)
                {
                    FF.log(w[z].ToString());
                }

            }
            */

            //-- at this stage, we have a simple list of inheritance, with 2 values:
            //-- parent and child.
            //-- now we need to resolve the full parent-children chain for each element.



            for (int n = 0; n < new_elements_chains.Count; n++)
            {
                container_children.Add(new_elements_chains[n]);
            }

            Boolean show = true;

            if (show == true)
            {

                FF.log("--------------------current lists----------------------");

                //-- values of root window --
                for (int n = 0; n < root_children.Count; n++)
                {
                    FF.log(root_children[n].ToString());
                }

                //-- values of all children --
                for (int n = 0; n < container_children.Count; n++)
                {
                    FF.log(container_children[n].ToString());
                }


                //-- Glade -XML code of each widget --
                /*
                for (int n = 0; n < container_list.Count; n++)
                {
                    //ArrayList widget = new ArrayList();
                    //ArrayList widget;
                    ArrayList widget = (ArrayList)container_list[n];
                    for (int i = 0; i < widget.Count; i++)
                    {
                        FF.log(widget[i].ToString());
                    }
                }
                
                */
            }

            //-----------------------------------



            string a;
            string c;
            string newstring;

            FF.log("--- calculating full dependency chain... ---");


            ArrayList chainlist = (ArrayList)root_children.Clone();

            ArrayList newlist = new ArrayList();

            int x;

            for (x = 0; x < 20; x++)
            {
                FF.log("------------------------------ loop ");
                //chainlist.Clear();
                Boolean finished = true;
                for (int n = 0; n < container_children.Count; n++)
                {

                    Boolean foundnode = false;

                    a = container_children[n].ToString();
                    if (!a.Contains("(empty)"))
                    {
                        finished = false;

                        string[] a_elements = Regex.Split(a, " --> ");

                        c = cutrighttrim(a_elements[1], "(");

                        newstring = "";
                        ArrayList templist = (ArrayList)chainlist.Clone();
                        for (int y = 0; y < templist.Count; y++)
                        {
                            string chain = templist[y].ToString();
                            string[] c_elements = Regex.Split(chain, " --> ");

                            string e = cutrighttrim(c_elements[c_elements.Length - 1], "(");
                            if (e.Equals(c))
                            {
                                newstring = chain + " --> " + a_elements[2];
                                
                                chainlist.Add(newstring);
                                //FF.log(".." + newstring);
                                foundnode = true;
                                break;
                            }
                        }

                        if (foundnode == true)
                        {
                            container_children[n] = "(empty) --> (empty) --> (empty) ";
                        }
                    }
                }
                if (finished == true)
                {
                    break;
                }
            }



            FF.log("");
            FF.log("");
            chainlist.Sort();
            FF.log("------------------------------------ chainlist... ---");
            for (int m = 0; m < chainlist.Count; m++)
            {
                newstring = chainlist[m].ToString();
                newstring = newstring.Replace("--- (rootchild) --> ", "");
                FF.log(newstring);
            }

            FF.log("");
            FF.log("");
            /*
            FF.log("------------------------------------ oldlist... ---");
            for (int m = 0; m < container_children.Count; m++)
            {
                FF.log(container_children[m].ToString());
            }
            */

             //---------------------------------------------------
            //-- now from the chains, generate the XML tree ! ---


            ArrayList o = new ArrayList();


            //-------- build head of gladefile -------

            o.Add("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>");
            o.Add("<!DOCTYPE glade-interface SYSTEM \"glade-2.0.dtd\">");
            o.Add("<!--Generated with glade3 3.0.3 on Sat Mar 21 04:00:14 2009 by csharp2vala-->");
            o.Add("<glade-interface>");
            o.Add("  <widget class=\"GtkWindow\" id=\"window1\">");
            o.Add("    <property name=\"visible\">True</property>");
            o.Add("    <signal name=\"destroy\" handler=\"" + thenamespace + "_on_window1_destroy\"/>");
            o.Add("    <child>");
            o.Add("    <widget class=\"GtkVBox\" id=\"rootwindowvbox\">");
            o.Add("    <property name=\"visible\">True</property>");
            o.Add("    <property name=\"orientation\">GTK_ORIENTATION_VERTICAL</property>");
            o.Add("    <property name=\"orientation\">GTK_ORIENTATION_VERTICAL</property>");
            o.Add("    <child>");
            o.Add("    <placeholder/>");
            o.Add("    </child>");
            o.Add("    <child>");
            o.Add("    <placeholder/>");
            o.Add("    </child>");
            o.Add("    <child>");
            o.Add("    <widget class=\"GtkHBox\" id=\"rootwindowhbox\">");
            o.Add("    <property name=\"visible\">True</property>");
            o.Add("    <property name=\"orientation\">GTK_ORIENTATION_HORIZONTAL</property>");
            o.Add("    <property name=\"orientation\">GTK_ORIENTATION_HORIZONTAL</property>");
            o.Add("    <child>");
            o.Add("    <placeholder/>");
            o.Add("    </child>");
            //-- add a fixed to place elements on --


            o.Add("  <child>");
            o.Add("     <widget class=\"GtkFixed\" id=\"rootwindowfixed\">");
            o.Add("        <property name=\"visible\">True</property>");

            


            chainlist.Add("<!--- END --->");
            //int child_depth = 0;
            ArrayList depth_widgets_pos = new ArrayList();
            ArrayList depth_widgets_id = new ArrayList();
            ArrayList depth_widgets_parentstring = new ArrayList();
            depth_widgets_id.Add("0");
            depth_widgets_pos.Add("0,0");
            depth_widgets_parentstring.Add("--");

            for (int n = 0; n < chainlist.Count-1; n++)
            {
                string theline = chainlist[n].ToString();

                string nextline = chainlist[n+1].ToString();
				
				Boolean closeformer = false;

                Boolean haschild = false;
                String parent = theline.Substring(0, theline.LastIndexOf(" --> "));

                if(nextline.Contains(theline)){
                    haschild = true;
                }

				//string formerline = "";
				//if (n>0){
				//	formerline = chainlist[n-1].ToString();
				//}
				
				if(! nextline.Contains(parent)){
                    closeformer = true;
                }
				
				//String nextparent = nextline.Substring(0, nextline.LastIndexOf(" --> "));
				//if(! nextparent.Contains(parent)){
                //    closeformer = true;
                //}
				

                int i1 = theline.LastIndexOf("[");
                int i2 = theline.LastIndexOf("]");

                // ID! - like: [24]
                int xmlid = Convert.ToInt32(theline.Substring(i1+1 , i2 - i1 -1));

                //pos! - like: (0, 0)
                string wx = "";
                string wy = "";

                i1 = theline.LastIndexOf("(");
                i2 = theline.LastIndexOf(")");
                string pos = theline.Substring(i1+1 , i2 - i1 -1).Replace("pos: " , "");
                //wx = pos.Split(',')[0].Trim();
                //wy = pos.Split(',')[1].Trim();

                depth_widgets_pos.Add(pos);
                depth_widgets_id.Add(xmlid.ToString());
                depth_widgets_parentstring.Add(theline);

                ArrayList w = (ArrayList)container_list[xmlid];
                FF.log("");
                FF.log("");
                FF.log(chainlist[n].ToString() );



                FF.log("  <CHILD>");
                o.Add("  <child>");

                int markerindex = 0;
                for (int i = 1; i < w.Count-1; i++)
                {
                    String widgetline = w[i].ToString();
                    if (widgetline.Equals("--MARKER--"))
                    {
                        markerindex = i;
                        break;
                    }

                    FF.log("  " + widgetline);
                    o.Add("  " + widgetline);
                }


                if (haschild == false)
                {
                    //child_depth--;
                    FF.log("  <--/***WIDGET***-->   ");
                    FF.log("  <***/CHILD>***");

                    //-- get and the closing code of a widget --
                    int orig_xmlid = Convert.ToInt32(depth_widgets_id[depth_widgets_id.Count - 1].ToString());
                    ArrayList nw = (ArrayList)container_list[orig_xmlid];
                    Boolean ok = false;
                    for (int i = 1; i < nw.Count - 1; i++)
                    {
                        String widgetline = nw[i].ToString();
                        if (ok == true)
                        {
                            o.Add(widgetline);
                        }
                        if (widgetline.Equals("--MARKER--"))
                        {
                            ok = true;
                        }
                    }
                    depth_widgets_id.RemoveAt(depth_widgets_id.Count - 1);
                    depth_widgets_parentstring.RemoveAt(depth_widgets_parentstring.Count - 1);

                    //o.Add("   </widget>");
                    //o.Add("   <packing>");
                    string thepos = depth_widgets_pos[depth_widgets_pos.Count -1].ToString();
                    depth_widgets_pos.RemoveAt(depth_widgets_pos.Count - 1);
                    wx = thepos.Split(',')[0].Trim();
                    wy = thepos.Split(',')[1].Trim();
                    o.Add("     <property name=\"x\">" + wx + "</property>");
                    o.Add("     <property name=\"y\">" + wy + "</property>");
                    o.Add("   </packing>");
                    o.Add("  </child>");

                }


                    if (closeformer == true)
                    {
                        //child_depth--;


                        for (int ne = depth_widgets_id.Count - 1; ne > 0; ne--)
                        {
                            if (! nextline.Contains(depth_widgets_parentstring[ne].ToString()))
                            {

                                FF.log("  <--/WIDGET-->   ");
                                FF.log("  <--/CHILD-->   ");

                                //-- get and the closing code of a widget --
                                int orig_xmlid = Convert.ToInt32(depth_widgets_id[depth_widgets_id.Count - 1].ToString());
                                ArrayList nw = (ArrayList)container_list[orig_xmlid];
                                Boolean ok = false;
                                for (int i = 1; i < nw.Count - 1; i++)
                                {
                                    String widgetline = nw[i].ToString();
                                    if (ok == true)
                                    {
                                        o.Add(widgetline);
                                    }
                                    if (widgetline.Equals("--MARKER--"))
                                    {
                                        ok = true;
                                    }
                                }
                                depth_widgets_id.RemoveAt(depth_widgets_id.Count - 1);
                                depth_widgets_parentstring.RemoveAt(depth_widgets_parentstring.Count - 1);

                                //o.Add("   </widget>");
                                //o.Add("   <packing>");
                                string thepos = depth_widgets_pos[depth_widgets_pos.Count - 1].ToString();
                                depth_widgets_pos.RemoveAt(depth_widgets_pos.Count - 1);
                                wx = thepos.Split(',')[0].Trim();
                                wy = thepos.Split(',')[1].Trim();
                                o.Add("     <property name=\"x\">" + wx + "</property>");
                                o.Add("     <property name=\"y\">" + wy + "</property>");
                                o.Add("   </packing>");
                                o.Add("</child>");
                            }
                        }
                    }
                    

                



            }

            o.Add("  </widget>");
            o.Add("  </child>");
            o.Add("    <child>");
            o.Add("    <placeholder/>");
            o.Add("    </child>");
            o.Add("  </widget>");

            o.Add("  </child>");
            o.Add("    <child>");
            o.Add("    <placeholder/>");
            o.Add("    </child>");
            o.Add("  </widget>");

 
            o.Add("  </child>");

            o.Add("  </widget>");
            o.Add("</glade-interface>");

            String outFile = outPath + "/project.glade";
            String[] outList = (string[])o.ToArray(typeof(string));
            FF.WriteAllLines(outFile + "3", outList);
            clean_gladefile(outFile + "3", outFile);

        }

        public void clean_gladefile(string thefile, string outFile)
        {
            String[] myList = FF.ReadAllLines(thefile);
            String[] myList2;
            myList2 = new String[myList.Length];

            int dc = 0;
            for (int n = 0; n < myList.Length; n++)
            {
                string theline = myList[n].Trim();
                //FF.log(theline.Substring(0, 2));
                if (! theline.Substring(0, 2).Equals("</"))
                {
                    if (!theline.Substring(0, 2).Equals("<!"))
                    {
                        if (!theline.Substring(0, 2).Equals("<?"))
                        {

                                    dc++;

                        }
                    }


                }
                string filler = "";
                for (int i = 0; i < dc; i++)
                {
                    filler += "  ";
                }
                myList2[n] = filler + theline;
                /*
                if (theline.Substring(0, 2).Equals("</"))
                {
                    dc--;
                    //FF.log(dc.ToString());
                }
                 */
                if (theline.Contains("</"))
                {
                    dc--;
                }
                if (theline.Contains("/>"))
                {
                    dc--;
                }
            }
            FF.WriteAllLines(outFile , myList2);

            FF.log(dc.ToString());
        }


        /*
        public ArrayList get_widget_xml_code(string widgetname)
        {

        }
         */

        public string cutrighttrim(string thestring, string delimiter)
        {

            if( ! thestring.Contains(delimiter)){
                return thestring.Trim();
            }
            int i1 = thestring.IndexOf(delimiter);
            string ret = thestring.Substring(0,i1);
            ret = ret.Trim();
            return ret;
        }

        public String xml_id(String line)
        {
            int i1=line.IndexOf(" id=");
            String id = line.Substring(i1 + 5);
            i1 = id.IndexOf("\"");
            id = id.Substring(0, i1);
            if (id.Length > 14)
            {
                if (id.Substring(0, 15).Equals("scrolledwindow_"))
                {
                    id = id.Substring(15);
                }else{
                    if (id.Substring(0, 9).Equals("eventbox_"))
                    {
                        id = id.Substring(9);
                    }else{
                        if (id.Substring(0, 10).Equals("CONTAINER_"))
                        {
                            id = id.Substring(10);
                        }
                    }

                }

            }
            return id;
        }

        public ArrayList find_nocontainer_children(String id, String[] theform)
        {

            //-- id has the name of a container --
			id = id.Replace("CONTAINER_" , "");
			
            ArrayList children = new ArrayList();

            //FF.log("+++++--" + id);

			for (int n = 0; n < container_list.Count; n++)
            {
                ArrayList w = (ArrayList)container_list[n];
                String widgetid = xml_id(w[1].ToString());
				widgetid = widgetid.Replace("CONTAINER_" , "");
                //FF.log("+++++" + widgetid);
                String pos = "";
                String childstring = "";
                Boolean ischild = false;
                string foundwidget = "";
                for(int i = 0; i< theform.Length; i++)
                {
                    if(theform[i].Contains("this." + id + ".Controls.Add(this." + widgetid + ")"))
                    {
                        ischild = true;
                        childstring = "--- (child) --> " + id + " --> " + widgetid;
                        foundwidget = widgetid;
                    }
                    if (theform[i].Contains("this." + widgetid + ".Location ="))
                    {
                        pos = get_pos(theform[i]);
                    }
                }

                //-- special case: new added elements like splitcontrol panels --
                /*
                for( int z = 0; z< w.Count();z++){
                    if(w[z].ToString().Contains("")){

                    }
                }
                */
                if (ischild == true)
                {
                    //FF.log("------->>> " + foundwidget);
                    int xid = 0;
                    for (int z = 0; z < container_list.Count; z++)
                    {
                        ArrayList w2 = (ArrayList)container_list[z];
                        String searchid = xml_id(w2[1].ToString());
						searchid = searchid.Replace("CONTAINER_" , "");
                        if (searchid.Equals(foundwidget))
                        {
                            xid = z;
                            break;
                        }
                    }

                    String newstring = childstring + " (pos: " + pos + ") [" + xid + "]";

                    FF.log(newstring);
                    children.Add(newstring);
                }
            }
            return children;
        }

        public String get_pos(String line)
        {
            int i1 = line.IndexOf("Point(") + 6;
            String pos = line.Substring(i1);
            i1 = pos.IndexOf(")");
            pos = pos.Substring(0, i1);
            return pos;
        }

        public ArrayList find_root_children(String[] theform)
        {

            //-- id has the name of a container --
            ArrayList children = new ArrayList();
            for (int n = 0; n < container_list.Count; n++)
            {
                ArrayList w = (ArrayList)container_list[n];
                String widgetid = xml_id(w[1].ToString());
				widgetid = widgetid.Replace("CONTAINER_" , "");
                Boolean isadded = false;
                string foundwidget = "";
                String pos = "";
                String childstring = "";
                for (int i = 0; i < theform.Length; i++)
                {
                    if (theform[i].Contains("this.Controls.Add(this." + widgetid + ")"))
                    {
                        isadded = true;
                        childstring = "--- (rootchild) --> *rootwindow* --> " + widgetid;
                        foundwidget = widgetid;
                    }
                    if (theform[i].Contains("this." + widgetid + ".Location ="))
                    {
                        pos = get_pos(theform[i]);
                    }

                }
                if (isadded == true)
                {

                    int xid = 0;
                    for (int z = 0; z < container_list.Count; z++)
                    {
                        ArrayList w2 = (ArrayList)container_list[z];
                        String searchid = xml_id(w2[1].ToString());
						searchid = searchid.Replace("CONTAINER_" , "");
                        if (searchid.Equals(foundwidget))
                        {
                            xid = z;
                            break;
                        }
                    }
 
                    String newstring = childstring + " (pos: " + pos + ") [" + xid + "]";

                    FF.log(newstring);
                    children.Add(newstring);
                }
            }
            return children;
        }



        public String[] is_valid_widget(String s1, String widgetname, String[] theform, String thenamespace)
        {

            String[] ret = new String[1];
            String[] xml;

            ret[0] = "";
            Containertype = "";

            //-- Button + optional label --
            if (s1.Contains("Forms.Button()"))
            {
                Glade_Button w = new Glade_Button();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }
            //-- CheckButton --
            if (s1.Contains("Forms.CheckBox()"))
            {
                Glade_CheckButton w = new Glade_CheckButton();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- RadioButton --
            if (s1.Contains("Forms.RadioButton()"))
            {
                Glade_RadioButton w = new Glade_RadioButton();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }
            //-- SpinButton --

            //--TODO: add values
            if (s1.Contains("Forms.NumericUpDown()"))
            {
                Glade_SpinButton w = new Glade_SpinButton();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- ComboBox --
            if (s1.Contains("Forms.ComboBox()"))
            {
                Glade_ComboBox w = new Glade_ComboBox();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- ProgressBar --

            //--TODO: add pulse_step?

            if (s1.Contains("Forms.ProgressBar()"))
            {
                Glade_ProgressBar w = new Glade_ProgressBar();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- Label --
            if (s1.Contains("Forms.Label()"))
            {
                Glade_Label w = new Glade_Label();
                //noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- LinkLabel --
            if (s1.Contains("Forms.LinkLabel()"))
            {
                Glade_LinkLabel w = new Glade_LinkLabel();
                noexpandflag = true;
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- TextBox --

            //--TODO: add scrolledwindow?

            //--TODO: add code for textbuffer?

            if (s1.Contains("Forms.TextBox()"))
            {
                Glade_TextBox w = new Glade_TextBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- MaskedTextBox --
            if (s1.Contains("Forms.MaskedTextBox()"))
            {
                Glade_MaskedTextBox w = new Glade_MaskedTextBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- RichTextBox --
            if (s1.Contains("Forms.RichTextBox()"))
            {
                Glade_RichTextBox w = new Glade_RichTextBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- ListBox --
            if (s1.Contains("Forms.ListBox()"))
            {
                Glade_ListBox w = new Glade_ListBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }
            //-- TreeView --
            if (s1.Contains("Forms.TreeView()"))
            {
                Glade_TreeView w = new Glade_TreeView();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- PictureBox --

            //--TODO: add path of selected picture (tricky, must parse resourcefile)

            if (s1.Contains("Forms.PictureBox()"))
            {
                Glade_PictureBox w = new Glade_PictureBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            if (s1.Contains("Forms.MonthCalendar()"))
            {
                Glade_MonthCalendar w = new Glade_MonthCalendar();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }

            //-- MenuBar --
            //--TODO: a lot...

            if (s1.Contains("Forms.MenuStrip()"))
            {
                Glade_MenuBar w = new Glade_MenuBar();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                //Containertype = "menubar";
                return xml;
            }

            //-- StatusBar --
            if (s1.Contains("Forms.StatusStrip()"))
            {
                Glade_StatusBar w = new Glade_StatusBar();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                return xml;
            }


            //-- TabControl --
            if (s1.Contains("Forms.TabControl()"))
            {
                Glade_TabControl w = new Glade_TabControl();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                Containertype = "notebook";
                return xml;
            }


            //-- SplitContainer --
            if (s1.Contains("Forms.SplitContainer()"))
            {
                Glade_SplitContainer w = new Glade_SplitContainer();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                Containertype = "splitcontainer";
                return xml;
            }

            //-- GroupBox --
            if (s1.Contains("Forms.GroupBox()"))
            {
                Glade_GroupBox w = new Glade_GroupBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                Containertype = "groupbox";
                return xml;
            }

            //-- Panel --
            if (s1.Contains("Forms.Panel()"))
            {
                Glade_Panel w = new Glade_Panel();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                Containertype = "panel";
                return xml;
            }
            //-- HBox --
            if (s1.Contains("Forms.FlowLayoutPanel()"))
            {
                Glade_HVBox w = new Glade_HVBox();
                xml = w.gen_XML(widgetname, theform, thenamespace);
                Containertype = "flow";
                return xml;
            }


            return ret;
        }
    }
}
