﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Collections;

namespace csharp2vala
{
    class Convertproject
    {
        //-- a wrapper class for file related methods --
        private FileFunctions FF = new FileFunctions();
        private Glade glade = new Glade();
 
        public String videfile;
        //-- this will contain the final filenames of the vala project --
        ArrayList valaProjectFiles;

        //-- this is used for Preferred Code (PC) --
        public bool skipnextline = false;

        //-- this is used for Preferred Code Blocks (PCB) --
        public bool skipnextlines = false;
        public bool donotconvertnextline = false;




        public void start()
        {


            valaProjectFiles = new ArrayList();
            String[] myFiles;
            String theLine;

            FF.log("");
            //FF.log("Convertproject: starting..." + Program.form1.projectFolder + "/" + Program.form1.get_projectname());
            //return;
            myFiles = FF.readFilenamesToStringArray(Program.form1.projectFolder + "/" + Program.form1.get_projectname(), ".cs");

            //FF.log(Program.form1.projectFolder);
            
            for(int n=0; n<myFiles.Length-1;n++)
            {
                theLine = myFiles[n];
                convertFile(theLine);
                
            }


            //-- Create a ValaIDE project file --

            build_vide(Program.form1.projectFolder);

            //-- Convert a Windows Form to a Glade XML file --

            glade.FormToGlade(Program.form1.projectFolder + "/" + Program.form1.get_projectname(), Program.form1.outPath);

            FF.log("Convertproject: finished!");
        }

        public void build_vide(String projectFolder)
        {

            /*--  Create a ValaIDE project file --
             *
             * it contains info what files belong to the project, and on which libraries it depends 
             * 
             */

            String vide = Program.form1.get_projectname();

            videfile = Program.form1.outPath + "/" + vide + ".vide";
            //FF.log("");
            //FF.log("-> " + projectFolder);
            //FF.log("-> " + Program.form1.outPath);
            //FF.log("--> " + vide);
            FF.log("Building: " + videfile);

            String l;
            l = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
            l += "<project>";
            l += "<name>";
            l += vide;
            l += "</name>";
            l += "<files>";

            for (int i = 0; i < valaProjectFiles.Count; i++)
            {
                if(! valaProjectFiles[i].Equals("Form1.Designer.vala")){
                    l += "<file>";
                    l += valaProjectFiles[i];
                    l += "</file>";
                }
            }
            l += "</files>";
            l += "<compiler><pkg>gtk+-2.0</pkg><pkg>libglade-2.0</pkg><pkg>gmodule-2.0</pkg>";
            
            if( FF.isWindows() ){
                l += "<options><other> -X \"-Wl,--export-all-symbols\" </other></options>";
            }else{
                l += "<options></options>";
            }

            l += "</compiler><author/><version/><license>None</license>";
            l += "</project>";
            
            FF.WriteAllText(videfile, l);



        }        

        public void convertFile(String theFile){

            String fileName;
            String outFile;

            int c=0;

            fileName = FF.GetFileName(theFile);

            FF.CreateDirectory(Program.form1.outPath);

            outFile = fileName;
            outFile = outFile.Replace(".cs", ".vala");
            outFile = outFile.Replace("Program.vala", "main.vala");
            valaProjectFiles.Add(outFile);
            outFile = Program.form1.outPath + "/" + outFile;

            FF.log("processing: " + theFile);

            String[] myList = FF.ReadAllLines(theFile);
 
            ArrayList outListArray = new ArrayList();

            //FF.log("" + myList.Length);

            String theLine;

            outListArray.Add("using Gtk;");
            c=1;

            skipnextline = false;
            skipnextlines = false;
            donotconvertnextline = false;

            for(int n=0; n<myList.Length;n++)
            {
                theLine = myList[n];

                /*-- here (convertline) every line in a .cs file is converted --
                 * 
                 *  if the last line was "Perferred Code" (PC), we skip the current one
                 * 
                 */

                if(skipnextline == false){
                    ArrayList newLines = convertline(theLine, fileName);
                    for (int i = 0; i < newLines.Count; i++)
                    {
                        outListArray.Add(newLines[i].ToString());
                        c++;
                    }
                }else{
                    if(skipnextlines == false){
                        skipnextline = false;
                    }
                }


            }
            String[] outList = (string[])outListArray.ToArray(typeof(string));
            FF.WriteAllLines(outFile, outList);
        }

        public ArrayList convertline(String theLine, String fileName)
        {
            /*-- here every line in a .cs file is converted --
             * 
             *  modified lines will be commented, and a new line is created.
             *  So more than one line is returned then.
             */

            ArrayList li = new ArrayList();
            String newLine = theLine;
            String check = "";

            if (theLine.Equals("")){
                li.Add("");
                return li;
            }

            String oldLine = newLine;
            //String trimmedline = theLine.Trim();



            //-- preferred code (one line) --

            if (FF.startswith("//PC " , newLine))
            {
                newLine = newLine.Replace("//PC ", "");
                li.Add(newLine);
                skipnextline = true;
                return li;
            }


            //-- preferred code (codeblocks) --

            if (FF.startswith("//PCB start" , newLine))
            {
                if (Program.showcomments == true)
                {
                    li.Add(newLine);
                }
                donotconvertnextline = true;
                return li;
            }
            if (FF.startswith("//PCB end" , newLine))
            {
                if (Program.showcomments == true)
                {
                    li.Add(newLine);
                }
                donotconvertnextline = false;
                return li;
            }

            if (donotconvertnextline == true)
            {
                int index = newLine.IndexOf("//");
                String newLineStart = newLine.Substring(0, index);
                String newLineEnd = newLine.Substring(index + 2, newLine.Length -index-2);
                newLine = String.Concat(newLineStart, newLineEnd);
                li.Add(newLine);
                return li;
            }

            //-- ignored code (codeblocks) --

            if (FF.startswith("//ICB start" , newLine))
            {
                if (Program.showcomments == true)
                {
                    li.Add(newLine);
                }
                skipnextlines = true;
                return li;
            }

            if (FF.startswith("//ICB end" , newLine))
            {
                if (Program.showcomments == true)
                {
                    li.Add(newLine);
                }
                skipnextlines = false;
                return li;

            }
            if (skipnextlines == true)
            {
                return li;
            }

            //-- general replacements --

            newLine = newLine.Replace("Console.WriteLine(", "print( \"%s\\n\", ");



            if (FF.startswith("using", newLine))
            {
                if (Program.showcomments == true)
                {
                    newLine = newLine.Replace("using", "//C2V//using");
                    li.Add(newLine);
                }                
                return li;
            }



            newLine = newLine.Replace("partial class", "class");


            //-- special case, main program --

            if(fileName.Equals("Program.cs")){

                newLine = newLine.Replace(" Main()", " main(string[] args)");

                if(FF.startswith("Application.EnableVisualStyles()" , newLine))
                {
                    newLine = newLine.Replace("Application.EnableVisualStyles();", "//C2V//Application.EnableVisualStyles();");
                    if (Program.showcomments == true)
                    {
                          li.Add(newLine);
                    }
                    return li;
                }
                if(FF.startswith("Application.SetCompatibleTextRenderingDefault(" , newLine))
                {
                    newLine = newLine.Replace("Application.SetCompatibleTextRenderingDefault(", "//C2V//Application.SetCompatibleTextRenderingDefault(");
                    if (Program.showcomments == true)
                    {
                        li.Add(newLine);
                    }
                    return li;
                }
                if(FF.startswith("Application.Run(new" , newLine))
                {
                    newLine = newLine.Replace("Application.Run(new", "//C2V//Application.Run(new");
                    if (Program.showcomments == true)
                    {
                        li.Add(newLine);
                    }

                    li.Add("            Gtk.init (ref args);");
                    li.Add("            var form1 = new Form1 ();");
                    li.Add("            Gtk.main ();");
                    return li;
                }

            }

            /*-- forms, currently just "Form1.cs" is supported --
             * 
             *  The corresponding Form1.Designer.cs is converted in Glade.cs.
             * 
             */

            if(fileName.Equals("Form1.cs")){

                newLine = newLine.Replace("class Form1 : Form", "class Form1");

                check = newLine;
                newLine = newLine.Replace("InitializeComponent();", "//C2V//InitializeComponent();");
                if (!newLine.Equals(check))
                {
                    li.Add(newLine);
                    li.Add("            var xml = new Glade.XML (\"project.glade\", null, null);");
                    li.Add("            xml.signal_autoconnect_full (connect_signals);");
                    li.Add("        }");
                    li.Add("        private void connect_signals (string handler_name, GLib.Object object, string signal_name,");
                    li.Add("                                      string? signal_data, GLib.Object? connect_object, bool after)");
                    li.Add("        {");
                    li.Add("            var module = Module.open (null, ModuleFlags.BIND_LAZY);");
                    li.Add("            void* sym;");
                    li.Add("            if (!module.symbol (handler_name, out sym)) {");
                    li.Add("                stdout.printf (\"Symbol not found: %s\\n\" , handler_name);");
                    li.Add("            } else {");
                    li.Add("                Signal.connect (object, signal_name, (GLib.Callback) sym, this);");
                    li.Add("            }");
                    li.Add("        }");

                    li.Add("        public void on_window1_destroy (Widget widget) {");
                    li.Add("                Gtk.main_quit ();");
                   // li.Add("        }");

                    return li;
                }

                check = newLine;
                //newLine = newLine.Replace("object sender, EventArgs e", "Widget sender");
                if(newLine.Contains("object sender, ")){
                    int i1 = newLine.IndexOf("object sender, ");
                    newLine = newLine.Substring(0, i1) + "Widget sender)" ;
                }
                if (!newLine.Equals(check))
                {
                    newLine = newLine.Replace("private void", "public void");
                }
            }


            if (Program.showcomments == true)
            {
                if(! newLine.Equals(oldLine))
                {
                    if (!newLine.Contains("//C2V//")) 
                    {
                        li.Add("//C2V//" + oldLine);
                    }
                }
            }
            li.Add(newLine);
            return li;
        }

    }
}
